#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <sys/mman.h>
#include <string.h>

#define dbgs stderr
#define MODNAME "sd_video"

static void cacheflush(void *start, size_t size)
{
   asm("mov r0, %0\n"
       "mov r1, %1\n"
       "mov r2, #0\n"
       "mov r7, #0xf0000\n"
       "add r7, #0x02\n"
       "swi #0\n" ::
       "g"(start), "g"((long)start+size) :
       "r0", "r1", "r2", "r7");
}

static void debug(char *txt) {
   fputs(txt, dbgs);
   fputs("\n", dbgs);
   fflush(dbgs);
}

static void debugn(char *txt) {
   fputs(txt, dbgs);
   fflush(dbgs);
}

static void injector(const char *path, const char *modname) {
	unsigned *handle;
	
	if ((handle = dlopen(NULL,RTLD_LAZY | RTLD_GLOBAL)) == NULL) {
		debug("Cannot open self!"); debug(dlerror());
		return;
   }

	unsigned *KeyCommon_SendKeyPressInput = dlsym(handle, "_ZN9KeyCommon17SendKeyPressInputEii");
	if (KeyCommon_SendKeyPressInput == NULL) {
		debug("Cannot find _ZN9KeyCommon17SendKeyPressInputEii function!");
		debug(dlerror());
		return;
   }
	dlclose(handle);

	char sbuf[256];
	sprintf(sbuf, "%s%s%s", path, modname, ".so");
	if ((handle = dlopen(sbuf, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL) {
		debugn("Cannot open '"); debugn(sbuf); debug("' !!!");
		debug(dlerror());
		return;
   }

   sprintf(sbuf, "mod_%s_injection", modname);
   unsigned *ex_injection = dlsym(handle, sbuf);
   if (ex_injection == NULL) {
      debug(dlerror()); dlclose(handle); return; }

   sprintf(sbuf, "mod_%s_set_path", modname);
   void (*ex_set_path)(char *);
   *(void **)(&ex_set_path) = dlsym(handle, sbuf);
   if (ex_set_path == NULL) {
      debug(dlerror()); dlclose(handle); return; }

   dlclose(handle);

   // code below based on universal loader by geo650
	debug("- injecting...");
 	int page = ((unsigned) KeyCommon_SendKeyPressInput) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);

	if (KeyCommon_SendKeyPressInput[4] == 0xE51FF004)	// remapped already (by other application) ?
	{
	   debug("- old injection detected");
	   // modify ex_injection returning command (self-injection)
	   int page2 = ((unsigned) ex_injection) & ~0x0FFF;
	   mprotect((void *) page2, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	   ex_injection[9]  = KeyCommon_SendKeyPressInput[4];
	   ex_injection[10] = KeyCommon_SendKeyPressInput[5];
	   mprotect((void *) page2, 8192, PROT_READ | PROT_EXEC);
	   cacheflush(ex_injection+9, 8);
	}
	// else first injection...
	// set "classic" injection function
	KeyCommon_SendKeyPressInput[4] = 0xE51FF004;
	KeyCommon_SendKeyPressInput[5] = (unsigned)ex_injection;
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);
	cacheflush(KeyCommon_SendKeyPressInput+4, 8);	
	
	// copy parameters to the main module
	debug("- calling set_path() function");
	(*ex_set_path)((char *)path);
	
	// injection complete!
	debug("injector() exiting");
}

int Game_Main(const char *path, const char *udn __attribute__ ((unused)))
{
	injector(path, MODNAME);
	return 1;
}
